Index: LMDZ4/trunk/libf/phylmd/YOMCST2.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/YOMCST2.h	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/YOMCST2.h	(revision 987)
@@ -9,4 +9,5 @@
      &               Supcrit1, Supcrit2,                                &
      &               choice,iflag_mix
+!$OMP THREADPRIVATE(/YOMCST2/)
 !    --------------------------------------------------------------------
 
Index: LMDZ4/trunk/libf/phylmd/add_phys_tend.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/add_phys_tend.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/add_phys_tend.F90	(revision 987)
@@ -38,5 +38,7 @@
 integer debug_level
 logical, save :: first=.true.
+!$OMP THREADPRIVATE(first)
 INTEGER, SAVE :: itap
+!$OMP THREADPRIVATE(itap)
 !======================================================================
 ! Initialisations
Index: LMDZ4/trunk/libf/phylmd/calltherm.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/calltherm.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/calltherm.F90	(revision 987)
@@ -86,4 +86,5 @@
       integer i,k
       logical, save :: first=.true.
+!$OMP THREADPRIVATE(first)
 !********************************************************
       if (first) then
Index: LMDZ4/trunk/libf/phylmd/comsoil.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/comsoil.h	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/comsoil.h	(revision 987)
@@ -5,2 +5,3 @@
       common /comsoil/inertie_sol,inertie_sno,inertie_ice
       real inertie_sol,inertie_sno,inertie_ice
+!$OMP THREADPRIVATE(/comsoil/)
Index: LMDZ4/trunk/libf/phylmd/concvl.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/concvl.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/concvl.F	(revision 987)
@@ -151,8 +151,11 @@
       SAVE      h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot
      $        , h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot
+c$OMP THREADPRIVATE(h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot)
+c$OMP THREADPRIVATE(h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot)
       REAL      d_h_vcol, d_h_dair, d_qt, d_qw, d_ql, d_qs, d_ec
       REAL      d_h_vcol_phy
       REAL      fs_bound, fq_bound
       SAVE      d_h_vcol_phy
+c$OMP THREADPRIVATE(d_h_vcol_phy)
       REAL      zero_v(klon)
       CHARACTER*15 ztit
@@ -160,7 +163,9 @@
       SAVE      ip_ebil
       DATA      ip_ebil/2/
+c$OMP THREADPRIVATE(ip_ebil)
       INTEGER   if_ebil ! level for energy conserv. dignostics
       SAVE      if_ebil
       DATA      if_ebil/2/
+c$OMP THREADPRIVATE(if_ebil)
 c+jld ec_conser
       REAL d_t_ec(klon,klev)    ! tendance du a la conersion Ec -> E thermique
@@ -170,5 +175,7 @@
       INTEGER nloc
       logical, save :: first=.true.
-      INTEGER, SAVE :: itap, igout 
+c$OMP THREADPRIVATE(first)
+      INTEGER, SAVE :: itap, igout
+c$OMP THREADPRIVATE(itap, igout)
 c
 #include "YOMCST.h"
@@ -229,7 +236,7 @@
 C===========================================================================
 C
-c$$$         open (56,file='supcrit.data')
-c$$$         read (56,*) Supcrit1, Supcrit2
-c$$$         close (56)
+cc$$$         open (56,file='supcrit.data')
+cc$$$         read (56,*) Supcrit1, Supcrit2
+cc$$$         close (56)
 c
          print*, 'supcrit1, supcrit2' ,supcrit1, supcrit2
Index: LMDZ4/trunk/libf/phylmd/cpl_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/cpl_mod.F90	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/cpl_mod.F90	(revision 987)
@@ -88,4 +88,9 @@
   !$OMP THREADPRIVATE(cpl_windsp2D)
   
+! variable for OPENMP parallelisation
+
+  INTEGER,ALLOCATABLE,DIMENSION(:),SAVE :: knon_omp
+  REAL,ALLOCATABLE,DIMENSION(:,:),SAVE ::  buffer_omp
+  
 
 CONTAINS
@@ -204,5 +209,7 @@
     idtime = INT(dtime)
 #ifdef CPP_COUPLE
+!$OMP MASTER    
     CALL inicma
+!$OMP END MASTER
 #endif
 
@@ -252,4 +259,12 @@
     ENDIF    ! is_sequential
     
+! OPENMP Initialization
+
+!$OMP MASTER
+  ALLOCATE(knon_omp(0:omp_size-1)) 
+  ALLOCATE(buffer_omp(klon_mpi,0:omp_size-1))       
+!$OMP END MASTER
+!$OMP BARRIER
+    
   END SUBROUTINE cpl_init
   
@@ -293,5 +308,7 @@
 #ifdef CPP_COUPLE
     il_time_secs=(itime-1)*dtime
+!$OMP MASTER
     CALL fromcpl(il_time_secs, tab_read_flds)
+!$OMP END MASTER
 #endif
     
@@ -305,9 +322,21 @@
     ENDIF
 
+!$OMP MASTER
+
 ! Save each field in a 2D array. 
-    read_sst(:,:)     = tab_read_flds(:,:,1)  ! Sea surface temperature
-    read_sic(:,:)     = tab_read_flds(:,:,2)  ! Sea ice concentration
-    read_alb_sic(:,:) = tab_read_flds(:,:,3)  ! Albedo at sea ice
-    read_sit(:,:)     = tab_read_flds(:,:,4)  ! Sea ice temperature
+
+    IF (OPA_version=='OPA9') THEN
+      read_sst(:,:)     = tab_read_flds(:,:,1)  ! Sea surface temperature
+      read_sic(:,:)     = tab_read_flds(:,:,2)  ! Sea ice concentration
+      read_sit(:,:)     = tab_read_flds(:,:,3)  ! Sea ice temperature
+      read_alb_sic(:,:) = tab_read_flds(:,:,4)  ! Albedo at sea ice
+    ELSE IF (OPA_version=='OPA8') THEN
+      read_sst(:,:)     = tab_read_flds(:,:,1)  ! Sea surface temperature
+      read_sic(:,:)     = tab_read_flds(:,:,2)  ! Sea ice concentration
+      read_alb_sic(:,:) = tab_read_flds(:,:,3)  ! Albedo at sea ice
+      read_sit(:,:)     = tab_read_flds(:,:,4)  ! Sea ice temperature
+    ELSE
+      STOP 'Bad OPA version for coupled model'
+    ENDIF
 
 !*************************************************************************************
@@ -332,5 +361,6 @@
        ENDDO
     ENDDO
-    
+!$OMP END MASTER
+
 !*************************************************************************************
 !  Transform seaice fraction, read_sic into pctsrf_sav
@@ -824,6 +854,8 @@
 !
 !*************************************************************************************
+!$OMP MASTER
     rriv2D(:,:) = 0.0
     rcoa2D(:,:) = 0.0
+!$OMP END MASTER
     CALL gath2cpl(rriv_in, rriv2D, knon, knindex)
     CALL gath2cpl(rcoa_in, rcoa2D, knon, knindex)
@@ -834,6 +866,8 @@
 !*************************************************************************************
     IF (MOD(itime, nexca) == 1) THEN
+!$OMP MASTER
        cpl_rriv2D(:,:) = 0.0
        cpl_rcoa2D(:,:) = 0.0
+!$OMP END MASTER
     ENDIF
 
@@ -842,6 +876,8 @@
 !
 !*************************************************************************************    
+!$OMP MASTER
     cpl_rriv2D(:,:) = cpl_rriv2D(:,:) + rriv2D(:,:) / FLOAT(nexca)
     cpl_rcoa2D(:,:) = cpl_rcoa2D(:,:) + rcoa2D(:,:) / FLOAT(nexca)
+!$OMP END MASTER
 
   END SUBROUTINE cpl_send_land_fields
@@ -874,5 +910,7 @@
 !
 !*************************************************************************************
+!$OMP MASTER
     rlic2D(:,:) = 0.0
+!$OMP END MASTER
     CALL gath2cpl(rlic_in, rlic2D, knon, knindex)
 
@@ -882,5 +920,7 @@
 !*************************************************************************************
     IF (MOD(itime, nexca) == 1) THEN
+!$OMP MASTER
        cpl_rlic2D(:,:) = 0.0
+!$OMP END MASTER
     ENDIF
 
@@ -889,5 +929,7 @@
 !
 !*************************************************************************************    
+!$OMP MASTER
     cpl_rlic2D(:,:) = cpl_rlic2D(:,:) + rlic2D(:,:) / FLOAT(nexca)
+!$OMP END MASTER
 
   END SUBROUTINE cpl_send_landice_fields
@@ -935,4 +977,6 @@
 ! Table with all fields to send to coupler
     REAL, DIMENSION(iim, jj_nb, jpflda2o1+jpflda2o2)     :: tab_flds
+    REAL, DIMENSION(klon_mpi)                            :: rlon_mpi, rlat_mpi
+
 #ifdef CPP_PARA
     INCLUDE 'mpif.h'
@@ -950,15 +994,32 @@
 !
 !*************************************************************************************
-    tab_flds(:,:,7)  = cpl_windsp2D(:,:)
-    tab_flds(:,:,8)  = cpl_sols2D(:,:,2)
-    tab_flds(:,:,9)  = cpl_sols2D(:,:,1)
-    tab_flds(:,:,10) = cpl_nsol2D(:,:,2)
-    tab_flds(:,:,11) = cpl_nsol2D(:,:,1)
-    tab_flds(:,:,12) = cpl_fder2D(:,:,2)
-    tab_flds(:,:,13) = cpl_evap2D(:,:,2)
-    tab_flds(:,:,14) = cpl_evap2D(:,:,1)
-    tab_flds(:,:,17) = cpl_rcoa2D(:,:)
-    tab_flds(:,:,18) = cpl_rriv2D(:,:)
-    
+!! AC >>
+
+!$OMP MASTER
+    IF (OPA_version=='OPA9') THEN
+      tab_flds(:,:,7)  = cpl_windsp2D(:,:)
+      tab_flds(:,:,14) = cpl_sols2D(:,:,2)
+      tab_flds(:,:,12) = cpl_sols2D(:,:,1)
+      tab_flds(:,:,15) = cpl_nsol2D(:,:,2)
+      tab_flds(:,:,13) = cpl_nsol2D(:,:,1)
+      tab_flds(:,:,16) = cpl_fder2D(:,:,2)
+      tab_flds(:,:,11) = cpl_evap2D(:,:,2)
+      tab_flds(:,:,18) = cpl_rriv2D(:,:)
+      tab_flds(:,:,19) = cpl_rcoa2D(:,:)
+    ELSE IF (OPA_version=='OPA8') THEN
+      tab_flds(:,:,7)  = cpl_windsp2D(:,:)
+      tab_flds(:,:,8)  = cpl_sols2D(:,:,2)
+      tab_flds(:,:,9)  = cpl_sols2D(:,:,1)
+      tab_flds(:,:,10) = cpl_nsol2D(:,:,2)
+      tab_flds(:,:,11) = cpl_nsol2D(:,:,1)
+      tab_flds(:,:,12) = cpl_fder2D(:,:,2)
+      tab_flds(:,:,13) = cpl_evap2D(:,:,2)
+      tab_flds(:,:,14) = cpl_evap2D(:,:,1)
+      tab_flds(:,:,17) = cpl_rcoa2D(:,:)
+      tab_flds(:,:,18) = cpl_rriv2D(:,:)
+    ELSE
+      STOP 'Bad OPA version for coupled model'
+    ENDIF
+
 !*************************************************************************************
 ! Transform the fraction of sub-surfaces from 1D to 2D array
@@ -966,4 +1027,6 @@
 !*************************************************************************************
     pctsrf2D(:,:,:) = 0.
+!$OMP END MASTER
+
     CALL gath2cpl(pctsrf(:,is_oce), pctsrf2D(:,:,is_oce), klon, unity)
     CALL gath2cpl(pctsrf(:,is_sic), pctsrf2D(:,:,is_sic), klon, unity)
@@ -975,38 +1038,46 @@
 ! 
 !*************************************************************************************      
-    DO j = 1, jj_nb
-       tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:iim,j), &
-            pctsrf2D(1:iim,j,is_lic)) / REAL(iim)
-    ENDDO
-    
-    
-    IF (is_parallel) THEN
-       IF (.NOT. is_north_pole) THEN
+    IF (is_omp_root) THEN
+
+      DO j = 1, jj_nb
+         tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:iim,j), &
+              pctsrf2D(1:iim,j,is_lic)) / REAL(iim)
+      ENDDO
+    
+    
+      IF (is_parallel) THEN
+         IF (.NOT. is_north_pole) THEN
 #ifdef CPP_PARA
-          CALL MPI_RECV(Up,1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,status,error)
-          CALL MPI_SEND(tmp_calv(1,1),1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,error)
+            CALL MPI_RECV(Up,1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,status,error)
+            CALL MPI_SEND(tmp_calv(1,1),1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,error)
 #endif
-       ENDIF
+         ENDIF
        
-       IF (.NOT. is_south_pole) THEN
+         IF (.NOT. is_south_pole) THEN
 #ifdef CPP_PARA
-          CALL MPI_SEND(tmp_calv(1,jj_nb),1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,error)
-          CALL MPI_RECV(down,1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,status,error)
+            CALL MPI_SEND(tmp_calv(1,jj_nb),1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,error)
+            CALL MPI_RECV(down,1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,status,error)
 #endif
-       ENDIF
+         ENDIF
        
-       IF (.NOT. is_north_pole .AND. ii_begin /=1) THEN
-          Up=Up+tmp_calv(iim,1)
-          tmp_calv(:,1)=Up
-       ENDIF
+         IF (.NOT. is_north_pole .AND. ii_begin /=1) THEN
+            Up=Up+tmp_calv(iim,1)
+            tmp_calv(:,1)=Up
+         ENDIF
        
-       IF (.NOT. is_south_pole .AND. ii_end /= iim) THEN
-          Down=Down+tmp_calv(1,jj_nb)
-          tmp_calv(:,jj_nb)=Down	 
-       ENDIF
-    ENDIF
-      
-
-    tab_flds(:,:,19) = tmp_calv(:,:)
+         IF (.NOT. is_south_pole .AND. ii_end /= iim) THEN
+            Down=Down+tmp_calv(1,jj_nb)
+            tmp_calv(:,jj_nb)=Down	 
+         ENDIF
+      ENDIF
+        
+      IF (OPA_version=='OPA9') THEN
+        tab_flds(:,:,17) = tmp_calv(:,:)
+      ELSE IF (OPA_version=='OPA8') THEN
+        tab_flds(:,:,17) = tmp_calv(:,:)
+      ELSE
+        STOP 'Bad OPA version for coupled model'
+      ENDIF
+
 
 !*************************************************************************************
@@ -1018,25 +1089,53 @@
 !
 !*************************************************************************************    
-    tab_flds(:,:,15) = 0.0
-    tab_flds(:,:,16) = 0.0
-    tmp_taux(:,:)    = 0.0
-    tmp_tauy(:,:)    = 0.0
-    
-
-    ! fraction oce+seaice
-    deno =  pctsrf2D(:,:,is_oce) + pctsrf2D(:,:,is_sic) 
-    ! For all valid grid cells containing some fraction of ocean or sea-ice
-    WHERE ( deno(:,:) /= 0 )
-       tab_flds(:,:,15) = cpl_rain2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-            cpl_rain2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-       tab_flds(:,:,16) = cpl_snow2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-            cpl_snow2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+      ! fraction oce+seaice
+      deno =  pctsrf2D(:,:,is_oce) + pctsrf2D(:,:,is_sic) 
+
+      IF (OPA_version=='OPA9') THEN
+
+        tab_flds(:,:,10) = 0.0
+        tmp_taux(:,:)    = 0.0
+        tmp_tauy(:,:)    = 0.0
+        ! fraction oce+seaice
+        ! For all valid grid cells containing some fraction of ocean or sea-ice
+        WHERE ( deno(:,:) /= 0 )
+           tab_flds(:,:,10) = cpl_snow2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                              cpl_snow2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+
+           tmp_taux = cpl_taux2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                      cpl_taux2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+           tmp_tauy = cpl_tauy2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                      cpl_tauy2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+        ENDWHERE
+        tab_flds(:,:,8) = (cpl_evap2D(:,:,1) - ( cpl_rain2D(:,:,1) + cpl_snow2D(:,:,1)))
+        tab_flds(:,:,9) = (cpl_evap2D(:,:,2) - ( cpl_rain2D(:,:,2) + cpl_snow2D(:,:,2)))
+
+      ELSE IF (OPA_version=='OPA8') THEN
+
+        tab_flds(:,:,15) = 0.0
+        tab_flds(:,:,16) = 0.0
+        tmp_taux(:,:)    = 0.0
+        tmp_tauy(:,:)    = 0.0
+        ! For all valid grid cells containing some fraction of ocean or sea-ice
+        WHERE ( deno(:,:) /= 0 )
+           tab_flds(:,:,15) = cpl_rain2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                              cpl_rain2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+           tab_flds(:,:,16) = cpl_snow2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                              cpl_snow2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
        
-       tmp_taux = cpl_taux2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-            cpl_taux2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-       tmp_tauy = cpl_tauy2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-            cpl_tauy2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-    ENDWHERE
-
+           tmp_taux = cpl_taux2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                      cpl_taux2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+           tmp_tauy = cpl_tauy2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                      cpl_tauy2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+        ENDWHERE
+
+      ELSE
+        STOP 'Bad OPA version for coupled model'
+      ENDIF
+    
+    ENDIF ! is_omp_root  
+
+
+! AC <<
 !*************************************************************************************
 ! Transform the wind components from local atmospheric 2D coordinates to geocentric 
@@ -1046,7 +1145,12 @@
 
 ! Transform the longitudes and latitudes on 2D arrays
-    CALL Grid1DTo2D_mpi(rlon,tmp_lon)
-    CALL Grid1DTo2D_mpi(rlat,tmp_lat)
-    
+    
+    CALL gather_omp(rlon,rlon_mpi)
+    CALL gather_omp(rlat,rlat_mpi)
+!$OMP MASTER
+    CALL Grid1DTo2D_mpi(rlon_mpi,tmp_lon)
+    CALL Grid1DTo2D_mpi(rlat_mpi,tmp_lat)
+!$OMP END MASTER    
+
     IF (is_sequential) THEN
        IF (is_north_pole) tmp_lon(:,1)     = tmp_lon(:,2)
@@ -1066,4 +1170,5 @@
 ! Transform the wind from local atmospheric 2D coordinates to geocentric 
 ! 3D coordinates 
+!$OMP MASTER
     CALL atm2geo (iim, jj_nb, tmp_taux, tmp_tauy, tmp_lon, tmp_lat, &
          tab_flds(:,:,1), tab_flds(:,:,2), tab_flds(:,:,3) )
@@ -1072,4 +1177,5 @@
     tab_flds(:,:,5)  = tab_flds(:,:,2)
     tab_flds(:,:,6)  = tab_flds(:,:,3)
+!$OMP END MASTER
 
 !*************************************************************************************
@@ -1107,5 +1213,7 @@
 #ifdef CPP_COUPLE
     il_time_secs=(itime-1)*dtime
+!$OMP MASTER
     CALL intocpl(il_time_secs, lafin, tab_flds(:,:,:))
+!$OMP END MASTER
 #endif
 
@@ -1131,4 +1239,5 @@
 !
   SUBROUTINE cpl2gath(champ_in, champ_out, knon, knindex)
+  USE mod_phys_lmdz_para
 ! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
 ! au coupleur.
@@ -1151,21 +1260,29 @@
 
 ! Output
-    REAL, DIMENSION(klon), INTENT(OUT)        :: champ_out
+    REAL, DIMENSION(klon_mpi), INTENT(OUT)        :: champ_out
 
 ! Local
     INTEGER                                   :: i, ig
-    REAL, DIMENSION(klon)                     :: tamp
-
-!*************************************************************************************
-!
+    REAL, DIMENSION(klon_mpi)                 :: temp_mpi
+    REAL, DIMENSION(klon)                     :: temp_omp
+
+!*************************************************************************************
+!
+    
+
 ! Transform from 2 dimensions (iim,jj_nb) to 1 dimension (klon)
-    CALL Grid2Dto1D_mpi(champ_in,tamp)
-
+!$OMP MASTER 
+    CALL Grid2Dto1D_mpi(champ_in,temp_mpi)
+!$OMP END MASTER
+
+    CALL scatter_omp(temp_mpi,temp_omp)
+    
 ! Compress from klon to knon
     DO i = 1, knon
        ig = knindex(i)
-       champ_out(i) = tamp(ig)
+       champ_out(i) = temp_omp(ig)
     ENDDO
-
+  
+   
   END SUBROUTINE cpl2gath
 !
@@ -1173,4 +1290,5 @@
 !
   SUBROUTINE gath2cpl(champ_in, champ_out, knon, knindex)
+  USE mod_phys_lmdz_para
 ! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
 ! au coupleur.
@@ -1199,20 +1317,24 @@
 !*************************************************************************************
     INTEGER                                :: i, ig
-    REAL, DIMENSION(klon)                  :: tamp
-
+    REAL, DIMENSION(klon)                  :: temp_omp
+    REAL, DIMENSION(klon_mpi)              :: temp_mpi
 !*************************************************************************************
 
 ! Decompress from knon to klon
-    tamp = 0.
+    temp_omp = 0.
     DO i = 1, knon
        ig = knindex(i)
-       tamp(ig) = champ_in(i)
+       temp_omp(ig) = champ_in(i)
     ENDDO
 
 ! Transform from 1 dimension (klon) to 2 dimensions (iim,jj_nb)
-    CALL Grid1Dto2D_mpi(tamp,champ_out)
-    
-    IF (is_north_pole) champ_out(:,1)=tamp(1)
-    IF (is_south_pole) champ_out(:,jj_nb)=tamp(klon)
+    CALL gather_omp(temp_omp,temp_mpi)
+
+!$OMP MASTER    
+    CALL Grid1Dto2D_mpi(temp_mpi,champ_out)
+    
+    IF (is_north_pole) champ_out(:,1)=temp_mpi(1)
+    IF (is_south_pole) champ_out(:,jj_nb)=temp_mpi(klon)
+!$OMP END MASTER
     
   END SUBROUTINE gath2cpl
Index: LMDZ4/trunk/libf/phylmd/cv3_inip.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/cv3_inip.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/cv3_inip.F	(revision 987)
@@ -52,16 +52,16 @@
 C
 
-c$$$        open(57,file='parameter_mix.data')
-c$$$
-c$$$        read(57,*) iflag_mix, scut
-c$$$        read(57,*)
-c$$$        if(iflag_mix .gt. 0) then
-c$$$	      read(57,*) qqa1, qqa2
-c$$$              read(57,*)
-c$$$              read(57,*) gammas, Fmax
-c$$$              read(57,*)
-c$$$              read(57,*) alphas
-c$$$         endif
-c$$$	 close(57)
+cc$$$        open(57,file='parameter_mix.data')
+cc$$$
+cc$$$        read(57,*) iflag_mix, scut
+cc$$$        read(57,*)
+cc$$$        if(iflag_mix .gt. 0) then
+cc$$$	      read(57,*) qqa1, qqa2
+cc$$$              read(57,*)
+cc$$$              read(57,*) gammas, Fmax
+cc$$$              read(57,*)
+cc$$$              read(57,*) alphas
+cc$$$         endif
+cc$$$	 close(57)
 
 c
Index: LMDZ4/trunk/libf/phylmd/cv3param.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/cv3param.h	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/cv3param.h	(revision 987)
@@ -22,3 +22,4 @@
      :                ,dtovsh, dpbase, dttrig
      :                ,dtcrit, tau, beta, alpha, alpha1, delta, betad
+!$OMP THREADPRIVATE(/cv3param/)
 
Index: LMDZ4/trunk/libf/phylmd/cva_driver.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/cva_driver.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/cva_driver.F	(revision 987)
@@ -308,4 +308,5 @@
       logical ok_inhib  ! True => possible inhibition of convection by dryness
       logical, save :: debut=.true. 
+c$OMP THREADPRIVATE(debut)
 
       real plcl1(klon)
@@ -412,4 +413,5 @@
       real hnk(nloc),unk(nloc),vnk(nloc)
       logical, save :: first=.true.
+c$OMP THREADPRIVATE(first)
 
 c
Index: LMDZ4/trunk/libf/phylmd/hgardfou.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/hgardfou.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/hgardfou.F	(revision 987)
@@ -23,4 +23,6 @@
       SAVE firstcall
       DATA firstcall /.TRUE./
+c$OMP THREADPRIVATE(firstcall)
+
       IF (firstcall) THEN
          PRINT*, 'hgardfou garantit la temperature dans [100,370] K'
Index: LMDZ4/trunk/libf/phylmd/inifis.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/inifis.F	(revision 983)
+++ LMDZ4/trunk/libf/phylmd/inifis.F	(revision 987)
@@ -7,5 +7,5 @@
      $           plat,plon,parea,
      $           prad,pg,pr,pcpp)
-      use dimphy
+      USE dimphy
       IMPLICIT NONE
 c
